/* ipc_send.c */
# define IPC_SEND_H
# include "ipc_send.h"

ssize_t sendn(int fd, char * buf, size_t len) {
   char *  ptr = buf;
   size_t  nc;
   ssize_t n;

   for (nc = len; nc > 0; ptr += n, nc -=n) {
      if ((n = send(fd, ptr, nc, 0)) <= 0)
         if (n < 0 && errno == EINTR)
            n = 0;
	 else 
            return (nc < len) ? len - nc : -1;
    }

    return len;
}
